<?php
/**
 * @package Joomla
 * @subpackage Abook
 * @copyright (C) 2010 Ugolotti Federica
 * @license GNU/GPL, see LICENSE.php
 * EventList is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * Abook is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with Abook; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

defined( '_JEXEC' ) or die( 'Restricted access' );

class AbookHelper
{
        public static function addSubmenu($vName)
        {
		JSubMenuHelper::addEntry(
                        JText::_('COM_ABOOK_SUBMENU_CPANEL'),
                        'index.php?option=com_abook&view=cpanel',
                        $vName == 'cpanel'
                );
                JSubMenuHelper::addEntry(
                        JText::_('COM_ABOOK_SUBMENU_BOOKS'),
                        'index.php?option=com_abook&view=books',
                        $vName == 'books'
                );
                /*JSubMenuHelper::addEntry(
                        JText::_('COM_ABOOK_SUBMENU_CATEGORIES'),
                        'index.php?option=com_categories&extension=com_abook',
                        $vName == 'categories'
                );*/
		JSubMenuHelper::addEntry(
        		JText::_('COM_ABOOK_SUBMENU_CATEGORIES'),
                	'index.php?option=com_abook&view=categories',
	                $vName == 'categories'
        	);
		JSubMenuHelper::addEntry(
                        JText::_('COM_ABOOK_SUBMENU_AUTHORS'),
                        'index.php?option=com_abook&view=authors',
                        $vName == 'authors'
                );
		JSubMenuHelper::addEntry(
                        JText::_('COM_ABOOK_SUBMENU_EDITORS'),
                        'index.php?option=com_abook&view=editors',
                        $vName == 'editors'
                );
		JSubMenuHelper::addEntry(
                        JText::_('COM_ABOOK_SUBMENU_LIBRARIES'),
                        'index.php?option=com_abook&view=libraries',
                        $vName == 'libraries'
                );
		JSubMenuHelper::addEntry(
                        JText::_('COM_ABOOK_SUBMENU_LOCATIONS'),
                        'index.php?option=com_abook&view=locations',
                        $vName == 'locations'
                );
		JSubMenuHelper::addEntry(
                        JText::_('COM_ABOOK_SUBMENU_TAGS'),
                        'index.php?option=com_abook&view=tags',
                        $vName == 'tags'
                );
		JSubMenuHelper::addEntry(
                        JText::_('COM_ABOOK_SUBMENU_TAG_GROUPS'),
                        'index.php?option=com_abook&view=taggroups',
                        $vName == 'taggroups'
                );
		JSubMenuHelper::addEntry(
                        JText::_('COM_ABOOK_SUBMENU_IMPORTEXPORT'),
                        'index.php?option=com_abook&view=importexport',
                        $vName == 'importexport'
                );
        }

	public static function getActions($categoryId = 0, $bookId = 0)
        {
                $user   = JFactory::getUser();
                $result = new JObject;

                if (empty($bookId) && empty($categoryId)) {
                        $assetName = 'com_abook';
                }
                else if (empty($bookId)) {
                        $assetName = 'com_abook.category.'.(int) $categoryId;
                }
                else {
                        $assetName = 'com_abook.book.'.(int) $bookId;
                }

                $actions = array(
                        'core.admin', 'core.manage', 'core.create', 'core.edit', 'core.edit.state', 'core.delete'
                );

                foreach ($actions as $action) {
                        $result->set($action,   $user->authorise($action, $assetName));
                }

                return $result;
        }

	public static function getCategoryActions($extension, $categoryId = 0)
        {
                $user           = JFactory::getUser();
                $result         = new JObject;
                $parts          = explode('.',$extension);
                $component      = $parts[0];

                if (empty($categoryId)) {
                        $assetName = $component;
                }
                else {
                        $assetName = $component.'.category.'.(int) $categoryId;
                }

                $actions = array(
                        'core.admin', 'core.manage', 'core.create', 'core.edit', 'core.edit.own', 'core.edit.state', 'core.delete'
                );

                foreach ($actions as $action) {
                        $result->set($action, $user->authorise($action, $assetName));
                }

                return $result;
        }
}
