<?php
/**
 * @package Joomla
 * @subpackage Abook
 * @copyright (C) 2010 Ugolotti Federica
 * @license GNU/GPL, see LICENSE.php
 * Abook is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * Abook is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with Abook; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.modellist' );

class AbookModelCpanel extends JModelList
{

	public function &getButtons()
        {
                if (empty($this->_buttons)) {
                        $this->_buttons = array(
                                array(
                                        'link' => JRoute::_('index.php?option=com_abook&task=book.add'),
                                        'image' => 'abook-book-add-48.png',
                                        'text' => JText::_('COM_ABOOK_ADD_NEW_BOOK'),
                                        'access' => array('core.admin', 'com_abook')
                                ),
				array(
                                        'link' => JRoute::_('index.php?option=com_abook&view=books'),
                                        'image' => 'abook-books-48.png',
                                        'text' => JText::_('COM_ABOOK_BOOKS'),
                                        'access' => array('core.admin', 'com_abook')
                                ),
				array(
                                        'link' => JRoute::_('index.php?option=com_abook&task=category.add'),
                                        'image' => 'abook-category-add-48.png',
                                        'text' => JText::_('COM_ABOOK_ADD_NEW_CATEGORY'),
                                        'access' => array('core.manage', 'com_abook')
                                ),
				array(
                                        'link' => JRoute::_('index.php?option=com_abook&view=categories'),
                                        'image' => 'abook-categories-48.png',
                                        'text' => JText::_('COM_ABOOK_CATEGORIES'),
                                        'access' => array('core.manage', 'com_abook')
                                ),
				array(
                                        'link' => JRoute::_('index.php?option=com_abook&task=author.add'),
                                        'image' => 'abook-author-add-48.png',
                                        'text' => JText::_('COM_ABOOK_ADD_NEW_AUTHOR'),
                                        'access' => array('core.admin', 'com_abook')
                                ),
                                array(
                                        'link' => JRoute::_('index.php?option=com_abook&view=authors'),
                                        'image' => 'abook-authors-48.png',
                                        'text' => JText::_('COM_ABOOK_AUTHORS'),
                                        'access' => array('core.admin', 'com_abook')
                                ),
				array(
                                        'link' => JRoute::_('index.php?option=com_abook&task=editor.add'),
                                        'image' => 'abook-editor-add-48.png',
                                        'text' => JText::_('COM_ABOOK_ADD_NEW_EDITOR'),
                                        'access' => array('core.admin', 'com_abook')
                                ),
                                array(
                                        'link' => JRoute::_('index.php?option=com_abook&view=editors'),
                                        'image' => 'abook-editors-48.png',
                                        'text' => JText::_('COM_ABOOK_EDITORS'),
                                        'access' => array('core.admin', 'com_abook')
                                ),
				array(
                                        'link' => JRoute::_('index.php?option=com_abook&task=library.add'),
                                        'image' => 'abook-library-add-48.png',
                                        'text' => JText::_('COM_ABOOK_ADD_NEW_LIBRARY'),
                                        'access' => array('core.admin', 'com_abook')
                                ),
                                array(
                                        'link' => JRoute::_('index.php?option=com_abook&view=libraries'),
                                        'image' => 'abook-libraries-48.png',
                                        'text' => JText::_('COM_ABOOK_LIBRARIES'),
                                        'access' => array('core.admin', 'com_abook')
                                ),
				array(
                                        'link' => JRoute::_('index.php?option=com_abook&task=location.add'),
                                        'image' => 'abook-location-add-48.png',
                                        'text' => JText::_('COM_ABOOK_ADD_NEW_LOCATION'),
                                        'access' => array('core.admin', 'com_abook')
                                ),
                                array(
                                        'link' => JRoute::_('index.php?option=com_abook&view=locations'),
                                        'image' => 'abook-locations-48.png',
                                        'text' => JText::_('COM_ABOOK_LOCATIONS'),
                                        'access' => array('core.admin', 'com_abook')
                                ),
				array(
                                        'link' => JRoute::_('index.php?option=com_abook&task=tag.add'),
                                        'image' => 'abook-tag-add-48.png',
                                        'text' => JText::_('COM_ABOOK_ADD_NEW_TAG'),
                                        'access' => array('core.admin', 'com_abook')
                                ),
                                array(
                                        'link' => JRoute::_('index.php?option=com_abook&view=tags'),
                                        'image' => 'abook-tags-48.png',
                                        'text' => JText::_('COM_ABOOK_TAGS'),
                                        'access' => array('core.admin', 'com_abook')
				),
				array(
                                        'link' => JRoute::_('index.php?option=com_abook&task=taggroup.add'),
                                        'image' => 'abook-taggroup-add-48.png',
                                        'text' => JText::_('COM_ABOOK_ADD_NEW_TAGGROUP'),
                                        'access' => array('core.admin', 'com_abook')
                                ),
                                array(
                                        'link' => JRoute::_('index.php?option=com_abook&view=taggroups'),
                                        'image' => 'abook-taggroups-48.png',
                                        'text' => JText::_('COM_ABOOK_TAGGROUPS'),
                                        'access' => array('core.admin', 'com_abook')
                                )
                        );
                }

                return $this->_buttons;
        }

	public function getBooks()
        {
		$_books = array();
                $query = 'SELECT count(*)'
                                        . ' FROM #__abbook'
                                        . ' WHERE published = 1'
                                        ;

                $this->_db->SetQuery($query);
                $_books['published'] = $this->_db->loadResult();

                $query = 'SELECT count(*)'
                                        . ' FROM #__abbook'
                                        . ' WHERE published = 0'
                                        ;

                $this->_db->SetQuery($query);
                $_books['unpublished'] = $this->_db->loadResult();

                $_books['total'] = array_sum($_books);

                return $_books;
        }
	
	function getCategories()
        {
                $_categories = array();
                $query = 'SELECT count(*)'
                                        . ' FROM #__abcategories'
                                        . ' WHERE published = 1 AND extension="com_abook"'
                                        ;

                $this->_db->SetQuery($query);
                $_categories['published'] = $this->_db->loadResult();

                $query = 'SELECT count(*)'
                                        . ' FROM #__abcategories'
                                        . ' WHERE published = 0 AND extension="com_abook"'
                                        ;

                $this->_db->SetQuery($query);
                $_categories['unpublished'] = $this->_db->loadResult();

                $_categories['total'] = array_sum($_categories);

                return $_categories;
        }
	
	function getAuthors()
        {
                $_authors = array();
                $query = 'SELECT count(*)'
                                        . ' FROM #__abauthor'
                                        ;

                $this->_db->SetQuery($query);
                $_authors['total'] = $this->_db->loadResult();

                return $_authors;
        }

	function getEditors()
        {
                $_editors = array();
                $query = 'SELECT count(*)'
                                        . ' FROM #__abeditor'
                                        ;

                $this->_db->SetQuery($query);
                $_editors['total'] = $this->_db->loadResult();

                return $_editors;
        }

        function getLibraries()
        {
                $_libraries = array();
                $query = 'SELECT count(*)'
                                        . ' FROM #__ablibrary'
                                        ;

                $this->_db->SetQuery($query);
                $_libraries['total'] = $this->_db->loadResult();

                return $_libraries;
        }

        function getLocations()
        {
                $_locations = array();
                $query = 'SELECT count(*)'
                                        . ' FROM #__ablocations'
                                        ;

                $this->_db->SetQuery($query);
                $_locations['total'] = $this->_db->loadResult();

                return $_locations;
        }

	function getMostrated()
        {
                // Lets load the data if it doesn't already exist
                if (empty( $this->_mostrated ))
                {
                        $query = "SELECT a.title, a.id, "
                        . ' ROUND( v.rating_sum / v.rating_count ) AS rating, v.rating_count '
                        . "\n FROM #__abbook AS a"
                        . ' JOIN #__abrating AS v ON a.id = v.book_id'
                        . ' GROUP BY a.id '
                        . ' ORDER BY v.rating_count DESC'
                        ;
                        $this->_mostrated = $this->_getList( $query, 0, 10 );
                }
                return $this->_mostrated;
        }

        function getMostread()
        {
                // Lets load the data if it doesn't already exist
                if (empty( $this->_mostread ))
                {
                        $query = "SELECT title, id, hits "
                                . " FROM #__abbook"
                                . ' ORDER BY hits DESC'
                                ;
                        $this->_mostread = $this->_getList( $query, 0, 10 );
                }
                return $this->_mostread;
        }
}	
