<?php
/**
 * @package Joomla
 * @subpackage Abook
 * @copyright (C) 2010 Ugolotti Federica
 * @license GNU/GPL, see LICENSE.php
 * Abook is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * Abook is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with Abook; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.modeladmin');
jimport( 'joomla.filesystem.file' );

class AbookModelImportexport extends JModelAdmin
{
	var $_categories = null;
	function __construct()
	{
		parent::__construct();

	}

	public function getTable($type = 'Category', $prefix = 'AbookTable', $config = array())
        {
                return JTable::getInstance($type, $prefix, $config);
        }

	public function getForm($data = array(), $loadData = true)
        {
                $form = $this->loadForm('com_abook.importexport', 'importexport', array('control' => 'jform', 'load_data' => $loadData));
                if (empty($form)) {
                        return false;
                }

                return $form;
        }

	function setExportType($export){
		$session = JFactory::getSession();
                $session->set('export', $export, 'Abook');
	}

	function getExportType(){
                $session = JFactory::getSession();
                $export=$session->get('export', array(), 'Abook');
		switch ($export['type']){
                        case 1:
				$ext=".sql";
			break;
			case 2:
				$ext=".csv";
			break;
		}
		return $ext;
        }

	function getExport()
	{
		$session = JFactory::getSession();
                $export=$session->get('export', array(), 'Abook');
//error_log(print_r($export, true), 3, '/tmp/debug.log');
		switch ($export['type']){
			case 1:
				$tables= array('#__abauthor', '#__abbook', '#__abbookauth', '#__abcategories', '#__abeditor', '#__ablibrary', '#__ablocations', '#__abrating', '#__abbooktag', '#__abtag', '#__abtag_groups');
				foreach ($tables as $table){
					$file=$this->datadumpSql($table);
				}
			break;
			case 2:
				$file=$this->datadumpCsv($export['category']);
			break;
		}

		return $file;
	}

	function datadumpCsv ($category) {
                $result = '';
                $resrt = '';
		$category=($category==0)?'': 'WHERE catid='.$category;
                $query = 'SELECT title, subtitle, alias, ideditor, price, '
			. "pag, user_id, created_by_alias, description, image, file, "
                        . " year, idlocation, idlibrary, vote, numvote, hits, published, qty, isbn, approved, userid, url, "
                        . " url_label, dateinsert, catalogo, checked_out, checked_out_time, access, metakey, metadesc, note, language, editedby, "
			. " GROUP_CONCAT(#__abbookauth.idauth SEPARATOR ',') as autori, "
			. " GROUP_CONCAT(#__abbooktag.idtag SEPARATOR ',') as tags "
			. ' FROM #__abbook '
			. ' LEFT JOIN #__abbookauth on #__abbookauth.idbook=#__abbook.id '
			. ' LEFT JOIN #__abbooktag on #__abbooktag.idbook=#__abbook.id '
			. $category
			. ' GROUP BY #__abbook.id';
                $this->_db->setQuery($query);
                $rows = $this->_db->loadAssocList();
                foreach($rows as $row){
                        $resrt = '"';
                        while (list($key, $value) = each($row)) {
                                $resrt .= mysql_real_escape_string($value).'";"';
                        }
                        $resrt = substr($resrt,0,-2);
                        $resrt .= "\r\n";
                        $result .= $resrt;
                }
                echo $result;
                return;
        }

	function datadumpSql ($table) {
	        $result = '';
        	$resrt = '';
	        $reslt = "";
	        $query = 'SELECT * FROM '.$table;
		if ($table=="#__abcategories"){
			$query .= ' WHERE title != "ROOT"';
		}
		$this->_db->setQuery($query);
		$rows = $this->_db->loadAssocList();
	        foreach($rows as $row){
	                $reslt .= "INSERT INTO ".$table." (";
        	        $resrt .= ") VALUES ('";
                	while (list($key, $value) = each($row)) {
	                        $reslt .= $key.",";
        	                $resrt .= mysql_real_escape_string($value)."','";
                	}
                	$reslt = substr($reslt,0,-1);
                	$resrt = substr($resrt,0,-2);
	                $resrt .= ");\n";
        	        $result .= ($reslt.$resrt);
                	$reslt ='';
	                $resrt ='';
        	}
        	echo $result . "\n\n\n";
		return;
        }
	
	function importSql($filename, $user, $version='J15') {
		$buffer = Jfile::read(JPATH_COMPONENT_ADMINISTRATOR.DS.'uninstall.sql');
		$buffer .= Jfile::read(JPATH_COMPONENT_ADMINISTRATOR.DS.'install.sql');
		$buffer .= Jfile::read(JPATH_COMPONENT_ADMINISTRATOR.DS."uploads".DS.$filename);
                $queries = JDatabase::splitSql($buffer);
		if (count($queries) == 0) {
                	// No queries to process
                        return 0;
                }
		foreach ($queries as $query){
                	$query = trim($query);
                        if ($query != '' && $query{0} != '#') {
                        	$this->_db->setQuery($query);	
                                if (!$this->_db->query()) {
                                	JError::raiseWarning(1, 'JDatabase::query: '.JText::_('SQL Error')." ".$this->_db->stderr(true));
                                	return false;
                                }
				//update book owner
                                if ($user!=''){
                                        $query=  " UPDATE #__abbook "
                                                  ." SET user_id=".$user;
                                        $this->_db->setQuery($query);
                                        $this->_db->query();
				//update category owner
                                        $query=  " UPDATE #__abcategories "
                                                  ." SET created_user_id=".$user.", modified_user_id=".$user
							."WHERE title!=ROOT";
                                        $this->_db->setQuery($query);
                                        $this->_db->query();
                                }
                        }
                }
		Jfile::delete(JPATH_COMPONENT_ADMINISTRATOR.DS."uploads".DS.$filename);
		//delete category asset_id
                $query = 'UPDATE #__abcategories SET asset_id=0';
                $this->_db->setQuery($query);
		$this->_db->query();
		//delete book asset_id
		$query = 'UPDATE #__abbook SET asset_id=0';
                $this->_db->setQuery($query);
		$this->_db->query();		
		//update category asset_id
		$query = $this->_db->getQuery(true);
		$query = 'SELECT * FROM #__abcategories WHERE title!="ROOT"';
		$this->_db->setQuery($query);
		$categories = $this->_db->loadAssocList();
		//error_log(print_r($data, true), 3, '/var/log/php.log');	
		foreach ($categories as $cat){
			// Getting the asset table
                        $category = JTable::getInstance('Category', 'AbookTable', array());

                        // Bind data to save content
                        if (!$category->bind($cat)) {
                                echo JError::raiseError(500, $category->getError());
                        }

                        // Check the content
                        if (!$category->check()) {
                                echo JError::raiseError(500, $category->getError());
                        }

                        // Insert the content
                        if (!$category->store()) {
                                echo JError::raiseError(500, $category->getError());
                        }
		}
                //update book asset_id
                $query = $this->_db->getQuery(true);
                $query = 'SELECT * FROM #__abbook';
                $this->_db->setQuery($query);
                $books = $this->_db->loadAssocList();
                //error_log(print_r($data, true), 3, '/var/log/php.log');       
                foreach ($books as $item){
                        // Getting the asset table
                        $book = JTable::getInstance('Book', 'AbookTable', array());

                        // Bind data to save content
                        if (!$book->bind($item)) {
                                echo JError::raiseError(500, $book->getError());
                        }

                        // Check the content
                        if (!$book->check()) {
                                echo JError::raiseError(500, $book->getError());
                        }

                        // Insert the content
                        if (!$book->store()) {
                                echo JError::raiseError(500, $book->getError());
                        }
                }
		//rebuild categories
                $table = $this->getTable();
                $model = JModelLegacy::getInstance('Category', 'AbookModel', array('ignore_request' => true));
                $model->setState('params', $this->getState('params'));
                $model->setState('category.component', 'com_abook');
                $model->rebuild();
		return count($queries);
	}

	function importCsv($csvfile, $category, $user, $version='') {
		$buffer = file($csvfile);
		$insertrows=0;
		for($i=0; $i<sizeof ($buffer); $i++) {
			$id=null;
			$authorsLine=array();
			$line = trim($buffer[$i]);
			//list($title, $subtitle, $alias, $gid, $gecos, $home, $shell) = explode(":", $data);
			if ($version==''){
				//cerca l'ultimo ";" della stringa e taglia la stringa fino all'ultimo punto e virgola
				$pos=strripos($line, ';');
				//il "+ 1" serve per togliere il ";" all'inizio, poi tolgo gli apici e lo faccio diventare un array
				$tagsLine = explode(',', preg_replace('/"/', '', substr($line, $pos + 1)));
				$line=substr($line, 0, $pos);
			}
			//cerca di nuovo l'ultimo ";" della stringa e sega la stringa fino all'ultimo punt e virgola
			$pos=strripos($line, ';');
			$bookLine = preg_replace('/";"/', '","', substr($line, 0, $pos));
//error_log($bookLine);
			//il "+ 1" serve per togliere il ";" all'inizio, poi tolgo gli apici e lo faccio diventare un array
			$authorsLine = explode(',', preg_replace('/"/', '', substr($line, $pos + 1)));
//error_log(print_r($authorsLine, true), 3, '/tmp/debug.log');
			$lang=$version==''?'language, ':'';
			$query=  " INSERT INTO #__abbook "
				." (title, subtitle, alias, ideditor, price, pag, user_id, created_by_alias, description, image, "
				." file, year, idlocation, idlibrary, vote, numvote, hits, published, qty, isbn, approved,"
				." userid, url, url_label, dateinsert, catalogo, checked_out, checked_out_time, access,"
				." metakey, metadesc, note, ".$lang."editedby, catid)"
				." VALUES (".$bookLine.",".$category.")";
			$this->_db->setQuery( $query );
			if (!$this->_db->query()) {
 	                       JError::raiseWarning(1, 'JDatabase::query: '.JText::_('SQL Error')." ".$this->_db->stderr(true));
			}else{
				$id=$this->_db->insertid();
				$insertrows=($id > 0) ? $insertrows + 1 : $insertrows;
				if (count($authorsLine)>0 && isset($id)){
					foreach($authorsLine as $authorID){
						$query=  " INSERT INTO #__abbookauth "
							." (idbook, idauth)"
							." VALUES (".$id.",".$authorID.")";
						$this->_db->setQuery( $query );
						$this->_db->query();
					}
				}
				//update book owner
				if ($user!=''){
					$query=  " UPDATE #__abbook "
                                        	  ." SET user_id=".$user
                                	          ." WHERE id=".$id;
                                	$this->_db->setQuery($query);
                                	$this->_db->query();
				}
		                //update book asset_id
                		$query = $this->_db->getQuery(true);
                		$query = 'SELECT * FROM #__abbook WHERE id='.$id;
		                $this->_db->setQuery($query);
		                $item = $this->_db->loadAssoc();
		                //error_log(print_r($data, true), 3, '/var/log/php.log');       
		                // Getting the asset table
	                        $book = JTable::getInstance('Book', 'AbookTable', array());

	                        // Bind data to save content
	                        if (!$book->bind($item)) {
                   	             echo JError::raiseError(500, $book->getError());
          	        	}

                        	// Check the content
	                        if (!$book->check()) {
	                                echo JError::raiseError(500, $book->getError());
	                        }

	                        // Insert the content
	                        if (!$book->store()) {
	                                echo JError::raiseError(500, $book->getError());
	                        }
				
				//sistema i permessi, joomla15 access 0,1,2 joomla16 access 1,2,3
                                if ($version=='j15'){
                                        $query = $this->_db->getQuery(true);
                                        $query=  " UPDATE #__abbook "
                                                        ." SET access=(access + 1), language='*'"
                                                        ." WHERE id=".$id;
                                        $this->_db->setQuery($query);
                                        $this->_db->query();
                                }
			}
		}
		/*$query	= "LOAD DATA LOCAL INFILE '" . $csvfile . "' INTO TABLE #__abbook"
			. " FIELDS TERMINATED BY ';' ENCLOSED BY '\"' LINES TERMINATED BY "."'\\n'"
			. " (title, subtitle, alias, ideditor, price, pag, user_id, created_by_alias, description, image, file, "
			. " year, idlocation, idlibrary, vote, numvote, hits, published, qty, isbn, approved, userid, url, "
			. " url_label, dateinsert, catalogo, checked_out, checked_out_time, access, metakey, metadesc)"
			. " SET catid = ".$category;
		$this->_db->setQuery( $query );	
		$this->_db->query();
		$rows=$this->_db->getAffectedRows();*/
		Jfile::delete($csvfile);
		return $insertrows;
	}
}
