<?php
/**
 * @package Joomla
 * @subpackage Abook
 * @copyright (C) 2010 Ugolotti Federica
 * @license GNU/GPL, see LICENSE.php
 * EventList is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * Abook is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with Abook; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
defined('_JEXEC') or die('Restricted access');
JHtml::addIncludePath(JPATH_COMPONENT_ADMINISTRATOR.DS.'helpers'.DS.'html');
$user   = JFactory::getUser();
$userId         = $user->get('id');
$listOrder      = $this->state->get('list.ordering');
$listDirn       = $this->state->get('list.direction');
$canOrder       = $user->authorise('core.edit.state', 'com_abook.book');
$saveOrder      = $listOrder == 'a.ordering';
?>
<form action="<?php echo JRoute::_('index.php?option=com_abook&view=books'); ?>" method="post" name="adminForm">
<fieldset id="filter-bar">
	<div class="filter-search fltlft">
		<label class="filter-search-lbl" for="filter_search"><?php echo JText::_('JSEARCH_FILTER_LABEL'); ?></label>
		<input type="text" name="filter_search" id="filter_search" value="<?php echo $this->state->get('filter.search'); ?>" title="<?php echo JText::_('COM_ABOOK_SEARCH_IN_TITLE'); ?>" />	
			<button type="submit" class="btn"><?php echo JText::_('JSEARCH_FILTER_SUBMIT'); ?></button>
			<button type="button" onclick="document.id('filter_search').value='';this.form.submit();"><?php echo JText::_('JSEARCH_FILTER_CLEAR'); ?></button>
	</div>
	<div class="filter-select fltrt">
		<select name="filter_published" class="inputbox" onchange="this.form.submit()">
                        <option value=""><?php echo JText::_('JOPTION_SELECT_PUBLISHED');?></option>
                        <?php echo JHtml::_('select.options', JHtml::_('jgrid.publishedOptions'), 'value', 'text', $this->state->get('filter.published'), true);?>
                </select>
		<select name="filter_category_id" class="inputbox" onchange="this.form.submit()">
                        <option value=""><?php echo JText::_('JOPTION_SELECT_CATEGORY');?></option>
                        <?php echo JHtml::_('select.options', JHtml::_('category.options', 'com_abook'), 'value', 'text', $this->state->get('filter.category_id'));?>
                </select>
		<select name="filter_language" class="inputbox" onchange="this.form.submit()">
                                <option value=""><?php echo JText::_('JOPTION_SELECT_LANGUAGE');?></option>
                                <?php echo JHtml::_('select.options', JHtml::_('contentlanguage.existing', true, true), 'value', 'text', $this->state->get('filter.language'));?>
                        </select>

	</div>
</fieldset>
<div id="editcell">
	<table class="adminlist">
	<thead>
		<tr>
			<th width="5">
				<?php echo JHTML::_('grid.sort',  'ID', 'a.id', $listDirn, $listOrder );?>
			</th>
			<th width="20">
				<input type="checkbox" name="checkall-toggle" value="" onclick="checkAll(this)" />
			</th>
			<th width="5">
                                <?php echo JText::_( 'COM_ABOOK_NOTE' ); ?>
                        </th>
			<th>
				<?php echo JText::_( 'COM_ABOOK_COVER' ); ?>
			</th>			
			<th>
				<?php echo JHTML::_('grid.sort',  'COM_ABOOK_TITLE', 'a.title', $listDirn, $listOrder );?>
			</th>
			<th>
                                <?php echo JText::_( 'COM_ABOOK_AUTHOR' ); ?>
                        </th>
			<th>
				<?php echo JHTML::_('grid.sort',  'COM_ABOOK_EDITOR', 'a.ideditor', $listDirn, $listOrder );?>
                        </th>
			<th>
                                <?php echo JHTML::_('grid.sort',  'COM_ABOOK_YEAR', 'a.year', $listDirn, $listOrder );?>
                        </th>
			<th>
                                <?php echo JHTML::_('grid.sort',  'COM_ABOOK_LOCATION', 'a.idlocation', $listDirn, $listOrder );?>
                        </th>
			<th>
                                <?php echo JHTML::_('grid.sort',  'COM_ABOOK_LIBRARY', 'a.idlibrary', $listDirn, $listOrder );?>
                        </th>
			<th>
                                <?php echo JHTML::_('grid.sort',  'COM_ABOOK_CATEGORY', 'a.catid', $listDirn, $listOrder );?>
                        </th>
			<th>
				<?php echo JHTML::_('grid.sort',  'COM_ABOOK_CATALOG', 'a.catalogo', $listDirn, $listOrder );?>
                        </th>
			<th>
				<?php echo JHtml::_('grid.sort', 'JPUBLISHED', 'a.published', $listDirn, $listOrder); ?>	
			</th>
			<th>
				<?php echo JHTML::_('grid.sort',  'COM_ABOOK_DATEINSERT', 'a.dateinsert', $listDirn, $listOrder );?>
                        </th>
			<th width="10%">
                        	<?php echo JHtml::_('grid.sort',  'JGRID_HEADING_ORDERING', 'a.ordering', $listDirn, $listOrder); ?>
                                <?php if ($saveOrder) :?>
                                	<?php echo JHtml::_('grid.order',  $this->items, 'filesave.png', 'books.saveorder'); ?>
                                <?php endif; ?>
                        </th>
			<th>
                                <?php echo JHTML::_('grid.sort',   'Access', 'access_level', $listDirn, $listOrder ); ?>
                        </th>
			<th width="5%">
                                <?php echo JHtml::_('grid.sort', 'JGRID_HEADING_LANGUAGE', 'a.language', $listDirn, $listOrder); ?>
                        </th>
		</tr>
	</thead>
<tfoot>
    <tr>
      <td colspan="16"><?php echo $this->pagination->getListFooter(); ?></td>
    </tr>
  </tfoot>
	<?php
	foreach ($this->items as $i => $item) :
	$ordering   = ($listOrder == 'a.ordering');
        $canCreate  = $user->authorise('core.create', 'com_abook.category.'.$item->catid);
        $canEdit    = $user->authorise('core.edit', 'com_abook.book.'.$item->id);
        $canCheckin = $user->authorise('core.manage', 'com_checkin') || $item->checked_out==$userId || $item->checked_out==0;
	$canEditOwn = $user->authorise('core.edit.own', 'com_abook.book.'.$item->id) && $item->user_id == $userId;
        $canChange  = $user->authorise('core.edit.state', 'com_abook.book.'.$item->id) && $canCheckin;

	$link2		= JRoute::_( 'index.php?option=com_abook&controller=editor&task=edit&cid[]='. $item->editorid );
	$link3          = JRoute::_( 'index.php?option=com_abook&controller=category&task=edit&cid[]='. $item->catid );
	?>
		<tr class="row<?php echo $i % 2; ?>">
			<td class="center">
				<?php echo $item->id; ?>
			</td>
			<td class="center">
				<?php echo JHtml::_('grid.id', $i, $item->id); ?>
			</td>
			<td class="center">
                        <?php if ($item->note!=""){
				echo JHTML::_("tooltip", $item->note, JText::_( 'COM_ABOOK_NOTE' ) );
				}?> 
                        </td>
			<td>
				<a href="#edit" onmouseover="return overlib('<img src=\'<?php echo $item->image!='' ? $this->baseURL.$item->image : $this->baseURL."components/com_abook/assets/images/nocover.png"; ?>\' />',WIDTH,200, HEIGHT,200)"  onmouseout="return nd()"; alt=""/><img src="<?php echo $item->image!='' ? $this->baseURL.$item->image : $this->baseURL."components/com_abook/assets/images/nocover.png"; ?>" border="0" width="24" height="24" alt="" /></a>
			</td>
			<td>
                        <?php if ($item->checked_out) : ?>
                        	<?php echo JHtml::_('jgrid.checkedout', $i, $item->editor, $item->checked_out_time, 'books.', $canCheckin); ?>
                        <?php endif; ?>
                        <?php if ($canEdit || $canEditOwn) : ?>
                        	<a href="<?php echo JRoute::_('index.php?option=com_abook&view=book&task=book.edit&id='.$item->id);?>"><?php echo $this->escape($item->title); ?></a>
                        <?php else : ?>
                                <?php echo $this->escape($item->title); ?>
                        <?php endif; ?>
			<p class="smallsub">
                                                <?php echo JText::sprintf('JGLOBAL_LIST_ALIAS', $this->escape($item->alias));?></p>
                        </td>
			<td>
                                <?php echo $item->author; ?>
                        </td>
			<td>
				<span class="editlinktip hasTip" title="<?php echo JText::_( 'EDIT EDITOR' );?>::<?php echo $item->editor; ?>">
                                <a href="<?php echo $link2; ?>"><?php echo $item->editor; ?></a>
                        </td>
			<td>
                                <?php echo $item->year; ?>
                        </td>
			<td>
                                <?php echo $item->location; ?>
                        </td>
			<td>
                                <?php echo $item->library; ?>
                        </td>
			<td>
				<span class="editlinktip hasTip" title="<?php echo JText::_( 'EDIT CATEGORY' );?>::<?php echo $item->category; ?>">
                                <a href="<?php echo $link3; ?>"><?php echo $item->category; ?></a>
                        </td>
			<td>
                                <?php echo $item->catalogo; ?>
                        </td>
			<td class="center">
				<?php echo JHtml::_('jgrid.published', $item->published, $i, 'books.', $canChange); ?>
			</td>
			<td class="center">
                                <?php echo $item->dateinsert; ?>
                        </td>
			<td class="order">
                        	<?php if ($canChange) : ?>
                                	<?php if ($saveOrder) :?>
                                        	<?php if ($listDirn == 'asc') : ?>
                                                	<span><?php echo $this->pagination->orderUpIcon($i, ($item->catid == @$this->items[$i-1]->catid), 'books.orderup', 'JLIB_HTML_MOVE_UP', $ordering); ?></span>
                                                        <span><?php echo $this->pagination->orderDownIcon($i, $this->pagination->total, ($item->catid == @$this->items[$i+1]->catid), 'books.orderdown', 'JLIB_HTML_MOVE_DOWN', $ordering); ?></span>
                                                        <?php elseif ($listDirn == 'desc') : ?>
                                                        <span><?php echo $this->pagination->orderUpIcon($i, ($item->catid == @$this->items[$i-1]->catid), 'books.orderdown', 'JLIB_HTML_MOVE_UP', $ordering); ?></span>
                                                	<span><?php echo $this->pagination->orderDownIcon($i, $this->pagination->total, ($item->catid == @$this->items[$i+1]->catid), 'books.orderup', 'JLIB_HTML_MOVE_DOWN', $ordering); ?></span>
                                        	<?php endif; ?>
                                        <?php endif; ?>
                                        <?php $disabled = $saveOrder ?  '' : 'disabled="disabled"'; ?>
                                        <input type="text" name="order[]" size="5" value="<?php echo $item->ordering;?>" <?php echo $disabled ?> class="text-area-order" />
                                 	<?php else : ?>
                                 <?php echo $item->ordering; ?>
                        	 <?php endif; ?>
                        </td>
			<td class="center">
                                <?php echo $this->escape($item->access_level); ?>
                        </td>
			<td class="center nowrap">
                                <?php if ($item->language=='*'):?>
                                        <?php echo JText::_('JALL'); ?>
                                <?php else:?>
                                	<?php echo $item->language_title ? $this->escape($item->language_title) : JText::_('JUNDEFINED'); ?>
                         	<?php endif;?>
                         </td>
		</tr>
	<?php endforeach;?>
	</table>
</div>
<input type="hidden" name="option" value="com_abook" />
<input type="hidden" name="task" value="" />
<input type="hidden" name="boxchecked" value="0" />
<input type="hidden" name="controller" value="book" />
<input type="hidden" name="filter_order" value="<?php echo $listOrder; ?>" />
<input type="hidden" name="filter_order_Dir" value="<?php echo $listDirn; ?>" />
<?php echo JHtml::_('form.token'); ?>
</form>
<div class="clr"></div>
<p><?php echo JHTML::_('credit.credit');?></p>
