<?php
/**
 * @package Joomla
 * @subpackage Jbook
 * @copyright (C) 2010 Ugolotti Federica
 * @license GNU/GPL, see LICENSE.php
 * EventList is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * Jbook is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with Jbook; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.view' );
JHTML::addIncludePath(JPATH_COMPONENT.DS.'helpers');
JHtml::_('behavior.tooltip');
class AbookViewBooks extends JView
{
	protected $items;
        protected $pagination;
        protected $state;
	public function display($tpl = null)
	{
		$this->state            = $this->get('State');
		$this->items            = $this->get('Items');
		$this->pagination       = $this->get('Pagination');
		// Check for errors.
                if (count($errors = $this->get('Errors'))) {
                        JError::raiseError(500, implode("\n", $errors));
                        return false;
                }

		$this->assign('baseURL', JURI::root());

                $this->addToolbar();
                parent::display($tpl);
        }
	protected function addToolbar()
	{
		$document       = JFactory::getDocument();
                $document->addStyleSheet('components/com_abook/assets/css/com_abook.css');
		$document->addScript('components/com_abook/assets/javascript/overlib_mini.js');
		$user           = JFactory::getUser();
		//require_once JPATH_COMPONENT.DS.'helpers'.DS.'abook.php';
		//$state  = $this->get('State');
                $canDo  = AbookHelper::getActions($this->state->get('filter.category_id'));

		JToolBarHelper::title(JText::_( 'COM_ABOOK_BOOK_MANAGER' ), 'books' );
		if ($canDo->get('core.create') || (count($user->getAuthorisedCategories('com_abook', 'core.create'))) > 0) {
                        JToolBarHelper::addNew('book.add','JTOOLBAR_NEW');
                }
                if ($canDo->get('core.edit') || ($canDo->get('core.edit.own'))) {
                        JToolBarHelper::editList('book.edit','JTOOLBAR_EDIT');
                }
		if ($canDo->get('core.edit.state')) {
                        JToolBarHelper::divider();
                        JToolBarHelper::publish('books.publish','JTOOLBAR_PUBLISH', true);
                        JToolBarHelper::unpublish('books.unpublish', 'JTOOLBAR_UNPUBLISH', true);
			JToolBarHelper::custom('books.resethits', 'refresh', '', 'COM_ABOOK_RESET_HITS', true);
                }

                if ($this->state->get('filter.published') == -2 && $canDo->get('core.delete')) {
                        JToolBarHelper::deleteList('', 'books.delete','JTOOLBAR_EMPTY_TRASH');
                        JToolBarHelper::divider();
                }
                else if ($canDo->get('core.edit.state')) {
                        JToolBarHelper::trash('books.trash');
                        JToolBarHelper::divider();
                }

                if ($canDo->get('core.admin')) {
                        JToolBarHelper::preferences('com_abook');
                        JToolBarHelper::divider();
                }
	}
}
