<?php
/**
 * @package Joomla
 * @subpackage Abook
 * @copyright (C) 2010 Ugolotti Federica
 * @license GNU/GPL, see LICENSE.php
 * EventList is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * Abook is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with Abook; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.view' );
JHTML::addIncludePath(JPATH_COMPONENT.DS.'helpers');
class AbookViewCategories extends JView
{
	protected $items;
        protected $pagination;
        protected $state;

	public function display($tpl = null)
        {
                $this->state            = $this->get('State');
                $this->items            = $this->get('Items');
                $this->pagination       = $this->get('Pagination');

                // Check for errors.
                if (count($errors = $this->get('Errors'))) {
                        JError::raiseError(500, implode("\n", $errors));
                        return false;
                }

                // Preprocess the list of items to find ordering divisions.
                foreach ($this->items as &$item) {
                        $this->ordering[$item->parent_id][] = $item->id;
                }

                $this->addToolbar();
                parent::display($tpl);
        }

	protected function addToolbar()
        {
		$categoryId     = $this->state->get('filter.category_id');
		$component= "com_abook";
		$canDo = AbookHelper::getActions($component, $categoryId);
		JToolBarHelper::title(   JText::_( 'COM_ABOOK_CATEGORY_MANAGER' ), 'categories' );
		if ($canDo->get('core.edit.state')) {
			JToolBarHelper::publishList('categories.publish', 'JTOOLBAR_PUBLISH', true);
                	JToolBarHelper::unpublishList('categories.unpublish', 'JTOOLBAR_UNPUBLISH', true);
		}
                //JToolBarHelper::deleteList('category.delete');
		if ($this->state->get('filter.published') == -2 && $canDo->get('core.delete', $component)) {
                        JToolBarHelper::deleteList('', 'categories.delete', 'JTOOLBAR_EMPTY_TRASH');
                }
                else if ($canDo->get('core.edit.state')) {
                        JToolBarHelper::trash('categories.trash');
                        JToolBarHelper::divider();
                }

		if ($canDo->get('core.edit' ) || $canDo->get('core.edit.own')) {
                	JToolBarHelper::editList('category.edit');
		}
		if ($canDo->get('core.create')) {
                	JToolBarHelper::addNew('category.add');
		}
		if ($canDo->get('core.admin')) {
                        JToolBarHelper::custom('categories.rebuild', 'refresh', '', 'JTOOLBAR_REBUILD', false);
                        JToolBarHelper::preferences('com_abook', '550');
                }
	}
}
