<?php
/**
 * @package Joomla
 * @subpackage Abook
 * @copyright (C) 2010 Ugolotti Federica
 * @license GNU/GPL, see LICENSE.php
 * Abook is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * Abook is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with Abook; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.view' );
JHTML::addIncludePath(JPATH_COMPONENT.DS.'helpers');
class AbookViewEditors extends JView
{
	protected $items;
        protected $pagination;
        protected $state;

        /**
         * Display the view
         */
        public function display($tpl = null)
        {
                $this->state            = $this->get('State');
                $this->items            = $this->get('Items');
                $this->pagination       = $this->get('Pagination');

                // Check for errors.
                if (count($errors = $this->get('Errors'))) {
                        JError::raiseError(500, implode("\n", $errors));
                        return false;
                }

                $this->addToolbar();
                parent::display($tpl);
        }

	protected function addToolbar()
        {
                $document       =  JFactory::getDocument();
                $document->addStyleSheet('components/com_abook/assets/css/com_abook.css');
                $document->addScript(DS.'includes'.DS.'js'.DS.'overlib_mini.js');

                require_once JPATH_COMPONENT.DS.'helpers'.DS.'abook.php';
                $state  = $this->get('State');
                $canDo  = AbookHelper::getActions($state->get('filter.category_id'));

                JToolBarHelper::title(JText::_( 'COM_ABOOK_EDITOR_MANAGER' ), 'editors' );
                if ($canDo->get('core.create')) {
                        JToolBarHelper::addNew('editor.add','JTOOLBAR_NEW');
                }
                if ($canDo->get('core.edit')) {
                        JToolBarHelper::editList('editor.edit','JTOOLBAR_EDIT');
                }

		if ($canDo->get('core.delete')) {
                        JToolBarHelper::deleteList('', 'editors.delete','JTOOLBAR_DELETE');
		}

		if ($canDo->get('core.admin')) {
                        JToolBarHelper::divider();
                        JToolBarHelper::preferences('com_abook');
                }
        }
}
