<?php
/**
 * @package Joomla
 * @subpackage Abook
 * @copyright (C) 2010 Ugolotti Federica
 * @license GNU/GPL, see LICENSE.php
 * Abook is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * Abook is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with Abook; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
defined('_JEXEC') or die('Restricted access');
$user   = JFactory::getUser();
$listOrder      = $this->state->get('list.ordering');
$listDirn       = $this->state->get('list.direction');
$canOrder       = $user->authorise('core.edit.state', 'com_abook.library');
$saveOrder      = $listOrder == 'a.ordering';
?>
<form action="<?php echo JRoute::_('index.php?option=com_abook&view=libraries'); ?>" method="post" name="adminForm">
	<fieldset id="filter-bar">
		<div class="filter-search fltlft">
                        <label class="filter-search-lbl" for="filter_search"><?php echo JText::_('JSEARCH_FILTER_LABEL'); ?></label>
                        <input type="text" name="filter_search" id="filter_search" value="<?php echo $this->state->get('filter.search'); ?>" title="<?php echo JText::_('COM_ABOOK_SEARCH_IN_NAME'); ?>" />
                        <button type="submit"><?php echo JText::_('JSEARCH_FILTER_SUBMIT'); ?></button>
                        <button type="button" onclick="document.id('filter_search').value='';this.form.submit();"><?php echo JText::_('JSEARCH_FILTER_CLEAR'); ?></button>
                </div>
		<div class="filter-select fltrt">
			<select name="filter_language" class="inputbox" onchange="this.form.submit()">
                                <option value=""><?php echo JText::_('JOPTION_SELECT_LANGUAGE');?></option>
                                <?php echo JHtml::_('select.options', JHtml::_('contentlanguage.existing', true, true), 'value', 'text', $this->state->get('filter.language'));?>
                        </select>
        </fieldset>
        <div class="clr"> </div>
	<table class="adminlist">
	<thead>
		<tr>
			<th width="5">
				<?php echo JText::_( 'ID' ); ?>
			</th>
			<th width="20">
				<input type="checkbox" name="checkall-toggle" value="" onclick="checkAll(this)" />	
			</th>			
			<th class="title">
                                <?php echo JHTML::_('grid.sort',  'COM_ABOOK_NAME', 'a.name', $listDirn, $listOrder );?>
			</th>
			<th width="10%">
                        	<?php echo JHtml::_('grid.sort', 'JGRID_HEADING_LANGUAGE', 'a.language', $listDirn, $listOrder); ?>
                        </th>
		</tr>
	</thead>
	<tfoot>
    		<tr>
      			<td colspan="9"><?php echo $this->pagination->getListFooter(); ?></td>
    		</tr>
  	</tfoot>
	<tbody>
	<?php
	foreach ($this->items as $i => $item) :	
		$ordering       = ($listOrder == 'a.ordering');
		$canCreate      = $user->authorise('core.create',               'com_abook.library.'.$item->id);
                $canEdit        = $user->authorise('core.edit',                 'com_abook.library.'.$item->id);
                $canCheckin     = $user->authorise('core.manage',               'com_checkin') || $item->checked_out==$user->get('id') || $item->checked_out==0;
                $canChange      = $user->authorise('core.edit.state',   'com_abook.library.'.$item->id) && $canCheckin;
		$link 		= JRoute::_( 'index.php?option=com_abook&task=library.edit&id='. $item->id );
		?>
		<tr class="row<?php echo $i % 2; ?>">
			<td class="center">
				<?php echo $item->id; ?>
			</td>
			<td>
				<?php echo JHtml::_('grid.id', $i, $item->id); ?>
			</td>
			<td>
                                        <?php if ($item->checked_out) : ?>
                                                <?php echo JHtml::_('jgrid.checkedout', $i, $item->owner, $item->checked_out_time, 'editors.', $canCheckin); ?>
                                        <?php endif; ?>
                                        <?php if ($canCreate || $canEdit) : ?>
                                        <a href="<?php echo $link;?>">
                                                <?php echo $this->escape($item->name); ?></a>
                                        <?php else : ?>
                                                <?php echo $this->escape($item->name); ?>
                                        <?php endif; ?>
					<p class="smallsub">
                                                <?php echo JText::sprintf('JGLOBAL_LIST_ALIAS', $this->escape($item->alias));?></p>
                        </td>
			<td class="center nowrap">
                        	<?php if ($item->language=='*'):?>
                                	<?php echo JText::_('JALL'); ?>
                                <?php else:?>
                                        <?php echo $item->language_title ? $this->escape($item->language_title) : JText::_('JUNDEFINED'); ?>
                                <?php endif;?>
                        </td>
		</tr>
	<?php endforeach; ?>
	</tbody>
	</table>
	<input type="hidden" name="task" value="" />
	<input type="hidden" name="boxchecked" value="0" />
        <input type="hidden" name="filter_order" value="<?php echo $listOrder; ?>" />
        <input type="hidden" name="filter_order_Dir" value="<?php echo $listDirn; ?>" />
	<?php echo JHtml::_('form.token'); ?>
</form>
<div class="clr"></div>
<p><?php echo JHTML::_('credit.credit');?></p>
