<?php
/**
 * @package Joomla
 * @subpackage Abook
 * @copyright (C) 2010 Ugolotti Federica
 * @license GNU/GPL, see LICENSE.php
 * Abook is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * Abook is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with Abook; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

defined('_JEXEC') or die('Restricted access'); 
JHtml::addIncludePath(JPATH_COMPONENT.DS.'helpers');
$pageClass = $this->params->get('pageclass_sfx');
?>
<div class="item-page<?php echo $this->escape($pageClass); ?>">
	<?php if ($this->params->def('show_page_heading', 1)) : ?>
		<h1><?php echo $this->params->get( 'page_heading');?></h1>
	<?php endif; ?>
	<?php if ($this->params->get( 'search', 1 )== 1) { ?>
                <?php echo JHTML::_('icon.search');?>
                <div class="clr"></div>
        <?php } ?>
        <?php if ($this->params->get( 'breadcrumb', 2 )== 2) { ?>
                <div class="abook-path">
                        <?php echo JHTML::_('icon.breadcrumb', $this->path);?>
                </div>
        <div class="clr"></div>
        <?php } ?>
	<h2><?php echo $this->book->title;?></h2>
	<h4><?php echo $this->book->subtitle;?></h4>
<div class="booktab<?php echo $this->escape($pageClass); ?>">
		<div class="cover<?php echo $this->escape($this->params->get('pageclass_sfx')); ?>">
		<?if ($this->book->image){
			echo '<a href="'.$this->book->image.'" 
                        style="cursor: pointer;" class="modal" title="'.JText::_('COM_ABOOK_COVEROF').' '.$this->book->title.'">
                        <img src="'.$this->book->image.'" hspace="5" vspace="5" width="80px" alt="'.JText::_('COM_ABOOK_COVEROF').' '.$this->book->title.'" />
                        </a>';
                }else{
                	echo '<img src="components/com_abook/assets/images/nocover.png" width="80" alt="'.JText::_('COM_ABOOK_NOCOVEROF').'" />';
                }
                ?>
                </div>
		<div class="bookdetails<?php echo $this->escape($this->params->get('pageclass_sfx')); ?>">
				<div>
					<label><?php echo JText::_('COM_ABOOK_CATEGORY');?>: </label>
						<a href="<?php echo AbookHelperRoute::getCategoryRoute($this->book->catslug);?>"><?php echo $this->book->category_title;?></a>
				</div>
				<?php $n=count($this->tags);
				if ($this->params->get('show_tags', 1) & $n > 0){?>
				<div>
                                        <label><?php echo JText::_('COM_ABOOK_TAGS');?>: </label>
					<?php
                                        $n=count($this->tags);
                                        $k=0;
                                        foreach ($this->tags as $tag){
                                                $k=$k +1;
						$link = AbookHelperRoute::getTagRoute($tag->slugtag);
                                                echo '<a href="' .$link .'">' .$tag->tag_name .'</a>';
                                                if ($n != $k) echo ", ";
                                        }
                                        ?>	
                                </div>
				<?php } ?>
				<?php
                                $a=count($this->authors);
                                if ($a > 0){?>
				<div>
					<label><?php echo JText::_('COM_ABOOK_AUTHOR');?>: </label>
					<?php
                        		$n=count($this->authors);
                        		$k=0;
                        		foreach ($this->authors as $author){
                                		$k=$k +1;
						$link = AbookHelperRoute::getAuthorRoute($author->slugauthor);
                                		echo '<a href="' .$link .'">' .$author->author_name .'</a>';
                                		if ($n != $k) echo ", ";
                        		}
                        		?>
				</div>
				<?php } ?>
				<?php if ($this->book->editor_name!=''){ ?>
			        <div>
                			<label><?php echo JText::_('COM_ABOOK_EDITOR');?>: </label><?php echo $this->book->editor_name;?>
			        </div>
				<?php } ?>
			        <?php if ($this->book->pag>0){ ?>
			        <div>
			                <label><?php echo JText::_('COM_ABOOK_PAGES');?>: </label><?php echo $this->book->pag;?>
			        </div>
			        <?php } ?>
			        <?php if ($this->book->price!=''){ ?>
			        <div>
			                <label><?php echo JText::_('COM_ABOOK_PRICE');?>: </label><?php echo $this->book->price;?>
			        </div>
			        <?php } ?>
			        <?php if ($this->book->isbn!=''){ ?>
			        <div>
			                <label><?php echo JText::_('COM_ABOOK_ISBN');?>: </label><?php echo $this->book->isbn;?>
			        </div>
			        <?php } ?>
			        <?php if ($this->book->library_name!=''){ ?>
			        <div>
			                <label><?php echo JText::_('COM_ABOOK_LIBRARY');?>: </label><?php echo $this->book->library_name;?>
			        </div>
			        <?php } ?>
				<?php if ($this->book->location_name!=''){ ?>
                                <div>
                                        <label><?php echo JText::_('COM_ABOOK_LOCATION');?>: </label><?php echo $this->book->location_name;?>
                                </div>
                                <?php } ?>
			        <?php if ($this->book->year!=0){ ?>
			        <div>
			                <label><?php echo JText::_('COM_ABOOK_YEAR');?>: </label><?php echo $this->book->year;?>
			        </div>
			        <?php } ?>
				<?php if ($this->book->catalogo!=""){ ?>
                                <div>
                                        <label><?php echo JText::_('COM_ABOOK_CATALOG');?>: </label><?php echo $this->book->catalogo;?>
                                </div>
                                <?php } ?>
				<?php if ($this->book->file!=""){ ?>
                                <div>
                                        <label><?php echo JText::_('COM_ABOOK_FILE');?>: </label>
						<a href="images/<?php echo $this->params->get('file_path').'/'.$this->book->file;?>"><?php echo $this->filename; ?></a>
                                </div>
                                <?php } ?>
			        <?php if ($this->book->url!='' && ($this->params->get('linkto')==1)){ ?>
			        <div>
			                <label><?php echo JText::_('COM_ABOOK_LINK');?>: </label><a href="<?php echo $this->book->url;?>"><img src="/components/com_abook/assets/images/link/<?php echo $this->params->get('linkimage');?>" alt="<?php echo JText::_('COM_ABOOK_LINK');?>" /> <?php echo $this->book->url_label;?></a>
			        </div>
			        <?php } ?>
				<?php if ($this->book->note!='' && $this->params->get('show_note', 1)==1){ ?>
                                <div>
                                        <label><?php echo JText::_('COM_ABOOK_NOTE');?>: </label><?php echo $this->book->note;?>
                                </div>
                                <?php } ?>
			</div>
	</div>
	<div class="best<?php echo $this->escape($this->params->get('pageclass_sfx')); ?>">
		<div class="bookhits<?php echo $this->escape($this->params->get('pageclass_sfx')); ?>">
			<?php if ($this->params->get( 'show_hits', 1 )==1){ ?>
				<strong><?php echo JText::_('COM_ABOOK_HITS');?>: </strong>
				<?php echo $this->book->hits;?>
			<?php } ?>
		</div>
		<div class="bookrating<?php echo $this->escape($this->params->get('pageclass_sfx')); ?>">
			<?php if ($this->params->get( 'view_rate', 1 )==1) { ?>
				<?php echo JHTML::_('icon.votebook', $this->book, $this->vote);?>	
			<?php } ?>
		</div>
	</div>
	<?php if ($this->book->description!=''){ ?>
	<div class="description<?php echo $this->escape($this->params->get('pageclass_sfx')); ?>">
			<div>
				<h3 class="<?php echo $this->escape($this->params->get('pageclass_sfx')); ?>"><?php echo JText::_('COM_ABOOK_REVIEW');?></h3>
			</div>
			<?php if ($this->book->authorreview!= '' && $this->params->get('show_writtenby')){?>
			<div class="createdby<?php echo $this->escape($this->params->get('pageclass_sfx')); ?>"><?php JText::printf( 'COM_ABOOK_WRITTEN_BY', $this->book->authorreview); ?></div>
			<?php }?>
			<?php echo $this->book->description;?>
	</div> 
	<?php } ?>
	<div class="createdate<?php echo $this->escape($this->params->get('pageclass_sfx')); ?>">
			<div style="float: left;">
				<?php
					if($this->params->get( 'view_date' )==1){
					echo JText::_('COM_ABOOK_DATE_INSERT');?>: <?php echo JHTML::_('date', $this->book->dateinsert, JText::_('DATE_FORMAT_LC1')) ?>
				<?php } ?>
			</div>
			<div style="float:right;"><?php echo JHTML::_('credit.credit') ?></div>
	</div>
	<div class="clr"></div>
	<?php if ($this->params->get( 'display_book_comments',1 ) == 1) {
        	if (JComponentHelper::isEnabled('com_jcomments', true)) {
                	include_once(JPATH_BASE.DS.'components'.DS.'com_jcomments'.DS.'jcomments.php');
                        echo '<br />'.JComments::show($this->book->id, 'com_abook', JText::_('COM_ABOOK_CATEGORY') .' '. $this->book->title);
                }
        }?>
</div>
<div class="clr"></div>
